"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var EasyImage = require("easyimage");
var gm = require("gm");
var ImageUtils = (function () {
    function ImageUtils() {
    }
    ImageUtils.procces = function (opt, cb) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        var img = ImageUtils.imageMagick(opt.src);
                        cb(img);
                        img.write(opt.dst, function (err, stdout, stderr, cmd) {
                            if (err) {
                                console.log(err);
                            }
                            err ? reject(err) : resolve();
                        });
                    })];
            });
        });
    };
    ImageUtils.optimize = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.procces(opt, function (img) {
                        if (opt.autoOrient) {
                            img.autoOrient();
                        }
                        img.quality(opt.quality);
                    })];
            });
        });
    };
    ImageUtils.convert = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, EasyImage.convert(opt)];
            });
        });
    };
    ImageUtils.resize = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.procces(opt, function (img) {
                        if (opt.autoOrient) {
                            img.autoOrient();
                        }
                        img.quality(opt.quality);
                        var resizeOpt = opt.ignoreAspectRatio ? '!' : '';
                        img.resize(opt.width, opt.height, resizeOpt);
                    })];
            });
        });
    };
    ImageUtils.rotate = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.procces(opt, function (img) {
                        if (opt.autoOrient) {
                            img.autoOrient();
                        }
                        img.quality(opt.quality);
                        img.rotate(opt.backgroundColor, opt.degrees);
                    })];
            });
        });
    };
    ImageUtils.crop = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.procces(opt, function (img) {
                        if (opt.autoOrient) {
                            img.autoOrient();
                        }
                        if (opt.isSetDirection) {
                            img.gravity(opt.direction);
                            img.crop(opt.width, opt.height);
                        }
                        else {
                            img.crop(opt.width, opt.height, opt.x, opt.y);
                        }
                        img.quality(opt.quality);
                    })];
            });
        });
    };
    ImageUtils.watermark = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var args, geometry;
            return __generator(this, function (_a) {
                args = [opt.src, opt.watermarkFilePath];
                geometry = opt.size + "+" + opt.horizontalOffset + "+" + opt.verticalOffset;
                geometry += opt.ignoreAspectRatio ? '!' : '';
                args.push('-geometry', geometry);
                if (opt.direction) {
                    args.push('-gravity', opt.direction);
                }
                args.push('-composite', opt.dst);
                return [2, EasyImage.execute('convert', args)];
            });
        });
    };
    ImageUtils.flip = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.procces(opt, function (img) {
                        if (opt.verticalFlip) {
                            img.flip();
                        }
                        if (opt.horizontalFlip) {
                            img.flop();
                        }
                    })];
            });
        });
    };
    ImageUtils.getImageMagickVersion = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, EasyImage.getImageMagickVersion()];
            });
        });
    };
    ImageUtils.imageMagick = gm.subClass({ imageMagick: true });
    return ImageUtils;
}());
exports.default = ImageUtils;
//# sourceMappingURL=ImageUtils.js.map